	AREA |.text|,CODE

	IMPORT |Load$$ARM7$$Base|
	IMPORT |Image$$ARM7$$Base|
	IMPORT |Image$$ARM7$$Limit|
	IMPORT |Image$$ARM7$$ZI$$Base|
	IMPORT |Image$$ARM7$$ZI$$Limit|
	
	IMPORT arm7main

	EXPORT bios_SPI_write
	EXPORT logtbl
	EXPORT lineartbl
	EXPORT __rt_div0
;---------------------
	ENTRY

	mov r0,#0x4000000
	str r0,[r0,#0x208]	;IME=0

	ldr r0,=0x3810000
	msr cpsr_c,#0x13
	sub sp,r0,#0x40		;SVC (swi) stack
	msr cpsr_c,#0x12
	sub sp,r0,#0x80		;IRQ stack
	msr cpsr_c,#0x1f
	sub sp,r0,#0x100	;user stack
	
	adr r4,copylist
	bl copy
	b arm7main
;- - - -
copy
	ldmia r4!,{r0-r2}
	sub r2,r2,r1
	mov r2,r2,lsr#2
	swi 0x0c0000
	mov pc,lr
;--------------------------------------------------------------
bios_SPI_write
	ldr r3,=0x2369
	bx r3
__rt_div0			;this keeps exception handling junk from getting linked in
	bx lr
;------------------------
	LTORG
copylist
	dcd 0xff000000, |Image$$ARM7$$ZI$$Base|, |Image$$ARM7$$ZI$$Limit|

logtbl				;some tables for sound
	INCBIN logtbl.bin
lineartbl
	INCBIN lineartbl.bin
;-----------------------
	END